class MutSuperFlak extends Mutator
	config(user);

var() config string ReplacedWeaponClassName;
var bool bInitialized;
var class<Weapon> ReplacedWeaponClass;
var string ReplacedWeaponPickupClassName;
var string ReplacedAmmoPickupClassName;

function Initialize()
{
    local int FireMode;

	bInitialized = true;
	ReplacedWeaponClass = class<Weapon>(DynamicLoadObject(ReplacedWeaponClassName,class'Class'));
	ReplacedWeaponPickupClassName = string(ReplacedWeaponClass.default.PickupClass);
    for( FireMode = 0; FireMode<2; FireMode++ )
    {
        if( (ReplacedWeaponClass.default.FireModeClass[FireMode] != None)
        && (ReplacedWeaponClass.default.FireModeClass[FireMode].default.AmmoClass != None)
        && (ReplacedWeaponClass.default.FireModeClass[FireMode].default.AmmoClass.default.PickupClass != None) )
        {
			ReplacedAmmoPickupClassName = string(ReplacedWeaponClass.default.FireModeClass[FireMode].default.AmmoClass.default.PickupClass);
			break;
		}
	}
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
    if ( !bInitialized )
		Initialize();

    bSuperRelevant = 0;

	if ( xWeaponBase(Other) != None )
	{
		if ( xWeaponBase(Other).WeaponType == ReplacedWeaponClass )
			xWeaponBase(Other).WeaponType = class'SuperFlakCannon';
		else
			return true;
	}
	else if ( WeaponPickup(Other) != None )
	{
		if ( string(Other.Class) == ReplacedWeaponPickupClassName )
			ReplaceWith( Other, "SuperFlak.SuperFlakPickup");
		else
			return true;
	}
	else if ( (Ammo(Other) != None) && (string(Other.Class) == ReplacedAmmoPickupClassName) )
		ReplaceWith( Other, "XWeapons.FlakAmmoPickup");
	else
		return true;

	return false;
}

defaultproperties
{
    ConfigMenuClassName="SuperFlak.SuperFlakConfig"
	GroupName="Super Flak"
    FriendlyName="Super Flak"
    Description="Replaces a weapon with the Super Flak Cannon."
    ReplacedWeaponClassName="XWeapons.Redeemer"
}